#ifndef _CTC_UTILS_H_
#define _CTC_UTILS_H_

#include <cutils/properties.h>
#include <inttypes.h>
#include <CTC_Common.h>
#include <string>

#define RETURN_IF(error, cond)                                                       \
    do {                                                                             \
        if (cond) {                                                                  \
            ALOGE("%s:%d return %s <- %s", __FUNCTION__, __LINE__, #error, #cond);   \
            return error;                                                            \
        }                                                                            \
    } while (0)

#define RETURN_VOID_IF(cond)                                                         \
    do {                                                                             \
        if (cond) {                                                                  \
            ALOGE("%s:%d return <- %s", __FUNCTION__, __LINE__, #cond);              \
            return;                                                                  \
        }                                                                            \
    } while (0)

struct AVCodecContext;
struct AVStream;

namespace aml {
std::string ctcVersion();

template <typename T>
T CTC_getConfig(const char* key, const T& defaultValue = T())
{
    char buf[PROP_VALUE_MAX];
    T value;

    if (property_get(key, buf, nullptr) > 0) {
        char* end = nullptr;
        value = strtoimax(buf, &end, 0);

        if (end == buf) {
            value = defaultValue;
        }
    } else {
        value = defaultValue;
    }

    return value;
}

typedef enum {
    OUTPUT_MODE_480I = 0,
    OUTPUT_MODE_480P,
    OUTPUT_MODE_576I,
    OUTPUT_MODE_576P,
    OUTPUT_MODE_720P,
    OUTPUT_MODE_1080I,
    OUTPUT_MODE_1080P,
    OUTPUT_MODE_4K2K24HZ,
    OUTPUT_MODE_4K2K25HZ,
    OUTPUT_MODE_4K2K30HZ,
    OUTPUT_MODE_4K2KSMPTE,
    OUTPUT_MODE_4K2KFAKE_5G,
    OUTPUT_MODE_4K2K60HZ,
    OUTPUT_MODE_4K2K60HZ_Y420,
    OUTPUT_MODE_4K2K50HZ,
    OUTPUT_MODE_4K2K50HZ_Y420
}OUTPUT_MODE;

const unsigned char mjpeg_addon_data[] = {
    0xff, 0xd8, 0xff, 0xc4, 0x01, 0xa2, 0x00, 0x00, 0x01, 0x05, 0x01, 0x01, 0x01,
    0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02,
    0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x01, 0x00, 0x03, 0x01,
    0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x10,
    0x00, 0x02, 0x01, 0x03, 0x03, 0x02, 0x04, 0x03, 0x05, 0x05, 0x04, 0x04, 0x00,
    0x00, 0x01, 0x7d, 0x01, 0x02, 0x03, 0x00, 0x04, 0x11, 0x05, 0x12, 0x21, 0x31,
    0x41, 0x06, 0x13, 0x51, 0x61, 0x07, 0x22, 0x71, 0x14, 0x32, 0x81, 0x91, 0xa1,
    0x08, 0x23, 0x42, 0xb1, 0xc1, 0x15, 0x52, 0xd1, 0xf0, 0x24, 0x33, 0x62, 0x72,
    0x82, 0x09, 0x0a, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x25, 0x26, 0x27, 0x28, 0x29,
    0x2a, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x43, 0x44, 0x45, 0x46, 0x47,
    0x48, 0x49, 0x4a, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5a, 0x63, 0x64,
    0x65, 0x66, 0x67, 0x68, 0x69, 0x6a, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79,
    0x7a, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8a, 0x92, 0x93, 0x94, 0x95,
    0x96, 0x97, 0x98, 0x99, 0x9a, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7, 0xa8, 0xa9,
    0xaa, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8, 0xb9, 0xba, 0xc2, 0xc3, 0xc4,
    0xc5, 0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8,
    0xd9, 0xda, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9, 0xea, 0xf1,
    0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9, 0xfa, 0x11, 0x00, 0x02, 0x01,
    0x02, 0x04, 0x04, 0x03, 0x04, 0x07, 0x05, 0x04, 0x04, 0x00, 0x01, 0x02, 0x77,
    0x00, 0x01, 0x02, 0x03, 0x11, 0x04, 0x05, 0x21, 0x31, 0x06, 0x12, 0x41, 0x51,
    0x07, 0x61, 0x71, 0x13, 0x22, 0x32, 0x81, 0x08, 0x14, 0x42, 0x91, 0xa1, 0xb1,
    0xc1, 0x09, 0x23, 0x33, 0x52, 0xf0, 0x15, 0x62, 0x72, 0xd1, 0x0a, 0x16, 0x24,
    0x34, 0xe1, 0x25, 0xf1, 0x17, 0x18, 0x19, 0x1a, 0x26, 0x27, 0x28, 0x29, 0x2a,
    0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49,
    0x4a, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5a, 0x63, 0x64, 0x65, 0x66,
    0x67, 0x68, 0x69, 0x6a, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7a, 0x82,
    0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8a, 0x92, 0x93, 0x94, 0x95, 0x96,
    0x97, 0x98, 0x99, 0x9a, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7, 0xa8, 0xa9, 0xaa,
    0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8, 0xb9, 0xba, 0xc2, 0xc3, 0xc4, 0xc5,
    0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9,
    0xda, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9, 0xea, 0xf2, 0xf3, 0xf4,
    0xf5, 0xf6, 0xf7, 0xf8, 0xf9, 0xfa
};

bool checkIfVideoLayerTaken();
void setVideoAxis();

OUTPUT_MODE get_display_mode();
void getPosition(OUTPUT_MODE output_mode, int *x, int *y, int *width, int *height);
void convert_pip_axis(int x, int y, int w, int h, int *dst_x,
                      int *dst_y, int *dst_w, int *dst_h);

struct CTC_MediaInfo {
    size_t aParaCount;
    size_t sParaCcount;
    VIDEO_PARA_T vPara;
    AUDIO_PARA_T aParas[MAX_AUDIO_PARAM_SIZE];
    SUBTITLE_PARA_T sParas[MAX_SUBTITLE_PARAM_SIZE];
    int64_t bitrate;
};

int getMediaInfo(const char* url, CTC_MediaInfo* mediaInfo);
void freeMediaInfo(CTC_MediaInfo* mediaInfo);

aformat_t convertToAFormat(int codecId);
vformat_t convertToVFormat(int codecId);
/*
//refactor CTC to  call Subtitleclient api
SUBTITLE_TYPE convertToSubFormat(int codecId);
*/
SubtitleType convertToSubFormat(int codecId);
void setSubtitleId(SUBTITLE_PARA_T* sPara, SubtitleType subType, size_t pid);

const char *CTC_convertCodecIdToMimeType(AVCodecContext *codec);
int32_t CTC_convertMimeTypetoCodecId(const char *mime);

void convertToVPara(AVStream* st, VIDEO_PARA_T* p);
void convertToAPara(AVStream* st, AUDIO_PARA_T* p);
void convertToSPara(AVStream* st, SUBTITLE_PARA_T* p, bool isMpegts=true);
}

#endif /* ifndef _CTC_UTILS_H_ */
